package redstone329.BasicSpleef;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

import org.bukkit.ChatColor;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

public class BasicSpleef extends JavaPlugin implements Listener
{
	public void onEnable() 
	{ 
		//Create plugin file
		File file=new File("plugins/BasicSpleef");  
		if (!file.isDirectory())
		{
			file.mkdir();
		}
		//Bukkit.getPluginManager().registerEvents(this, this);
	}
	
	/*@EventHandler
	public void onPlayerInteractEvent(PlayerInteractEvent event)
	{
			Block block = event.getClickedBlock();
			Location location = block.getLocation();
			Player player = event.getPlayer();
			player.sendMessage("X:" + location.getBlockX()+" Y:" + location.getBlockY()+" Z:" + location.getBlockZ());
	}*/
	
	void fill(int x1, int y1, int z1, int x2, int y2, int z2, World world)
	{
		    for (int xPoint = (x1 <= x2 ? x1 :x2); xPoint <= (x1 <= x2 ? x2 :x1); xPoint++)
		    { 
		    	for (int yPoint = (y1 <= y2 ? y1 :y2); yPoint <= (y1 <= y2 ? y2 :y1); yPoint++)
		        {
		        	for (int zPoint = (z1 <= z2 ? z1 :z2); zPoint <= (z1 <= z2 ? z2 :z1); zPoint++)
		            {
		                Block currentBlock = world.getBlockAt(xPoint, yPoint, zPoint);
		                currentBlock.setTypeId(80);
		            }
		        }
		    }
	}
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args)
	{
		Player player = (Player) sender;
		if (!player.isOp())
		{
			sender.sendMessage(ChatColor.RED+"OPs Only!");
			return false;
		}
	    if(cmd.getName().equalsIgnoreCase("snow"))
	    {
	    	if (args.length == 6)
	    	{
	    		int x1 = Integer.parseInt(args[0]);
	    		int y1 = Integer.parseInt(args[1]);
	    		int z1 = Integer.parseInt(args[2]);
	    		int x2 = Integer.parseInt(args[3]);
	    		int y2 = Integer.parseInt(args[4]);
	    		int z2 = Integer.parseInt(args[5]);
	    		
	    		fill(x1,y1,z1,x2,y2,z2,player.getWorld());
	    	}
	    	else
	    	{
	    		sender.sendMessage("/snow x1 y1 z1 x2 y2 z2");
	    	}
	    }
	    if(cmd.getName().equalsIgnoreCase("setarena"))
	    {
	    	if (args.length == 7)
	    	{
	    		try 
	    		{
	    			if (args[0].substring(0, 1).matches("[0-9]"))
		    		{
		    			sender.sendMessage("Name cannot contain a number!");
		    		}
	    			else
					{
	    				FileWriter fileWriter = new FileWriter("plugins/BasicSpleef/Arenas.save", true);
	    				PrintWriter printWriter = new PrintWriter(fileWriter);
	    				printWriter.println(" " +args[0] + " " +args[1] + " "+args[2] + " "+args[3] + " "+args[4] + " "+args[5] + " "+args[6]);
	    				printWriter.close();
					
	    				//now send
	    				int x1 = Integer.parseInt(args[1]);
	    				int y1 = Integer.parseInt(args[2]);
	    				int z1 = Integer.parseInt(args[3]);
	    				int x2 = Integer.parseInt(args[4]);
	    				int y2 = Integer.parseInt(args[5]);
	    				int z2 = Integer.parseInt(args[6]);
	    				fill(x1,y1,z1,x2,y2,z2,player.getWorld());
					}
				} 
	    		catch (IOException e) 
	    		{
					sender.sendMessage("Bad Write!");
				}
	    	}
	    	else
	    	{
	    		sender.sendMessage("/setarena name x1 y1 z1 x2 y2 z2");
	    	}
	    }
	    if(cmd.getName().equalsIgnoreCase("resetarena"))
	    {
	    	if (args.length == 1)
	    	{
	    		try 
	    		{
	    			boolean found = false;
	    			int x1 = 0;
		    		int y1 = 0;
		    		int z1 = 0;
		    		int x2 = 0;
		    		int y2 = 0;
		    		int z2 = 0;
	    			//FileReader fileReader = new FileReader("plugins/BasicSpleef/Arenas.save");
	    			//BufferedReader bufferedReader = new BufferedReader(fileReader);
		    		Scanner scanner = new Scanner(new File("plugins/BasicSpleef/Arenas.save"));
	    			String read = scanner.useDelimiter("\\Z").next();
	    			String[] content=read.split(" ");
	    			
	    			for (int loop = 1; loop < content.length; loop++)//start at one because of space
	    			{
	    				if (args[0].replaceAll("\\s","").equals(content[loop].replaceAll("\\s","")))
	    				{
	    					x1 = Integer.parseInt(content[loop+1].replaceAll("\\s",""));
	    		    		y1 = Integer.parseInt(content[loop+2].replaceAll("\\s",""));
	    		    		z1 = Integer.parseInt(content[loop+3].replaceAll("\\s",""));
	    		    		x2 = Integer.parseInt(content[loop+4].replaceAll("\\s",""));
	    		    		y2 = Integer.parseInt(content[loop+5].replaceAll("\\s",""));
	    		    		z2 = Integer.parseInt(content[loop+6].replaceAll("\\s",""));
	    		    		found = true;
	    		    		break;
	    				}
	    				// I want loop to loop by 7 and the next line makes up for the for statement only allowing loop++
	    				loop=loop+6;// equivalent to 7
	    			}
	    			if (!found)
	    			{
	    				sender.sendMessage("Arena Not found!");
	    			}
	    			//now send
		    		scanner.close();
		    		if (found)
		    		{
		    			fill(x1,y1,z1,x2,y2,z2,player.getWorld());
		    		}
				} 
	    		catch (IOException e) 
	    		{
					sender.sendMessage("Bad Read!");
				}
	    	}
	    	else
	    	{
	    		sender.sendMessage("/resetarena name");
	    	}
	    }
	    if(cmd.getName().equalsIgnoreCase("listarenas"))
	    {
	    		try 
	    		{
	    			//FileReader fileReader = new FileReader("plugins/BasicSpleef/Arenas.save");
	    			//BufferedReader bufferedReader = new BufferedReader(fileReader);
		    		Scanner scanner = new Scanner(new File("plugins/BasicSpleef/Arenas.save"));
	    			String read = scanner.useDelimiter("\\Z").next();
	    			String[] content=read.split(" ");
	    			String names = "";
	    			for (int loop = 1; loop < content.length; loop++)//start at one because of space
	    			{
	    				names = names + content[loop] + " ";
	    				// I want loop to loop by 7 and the next line makes up for the for statement only allowing loop++
	    				loop=loop+6;// equivalent to 7
	    			}
	    			sender.sendMessage(names);
	    			//now send
		    		scanner.close();
				} 
	    		catch (IOException e) 
	    		{
					sender.sendMessage("Bad Read!");
				}
	    	
	    }
	    return false;
	}
}

